from discord import ui, ButtonStyle, Interaction, SelectOption
from redbot.core import commands

from aurora.configuration.embed import embed
from aurora.utilities.config import config

class Overrides(ui.View):
    def __init__(self, ctx: commands.Context):
        super().__init__()
        self.ctx = ctx

    @ui.select(cls=ui.Select, placeholder="Auto Evidence Format", row=0, options=[
        SelectOption(label="Enabled", value=1, emoji="✅"),
        SelectOption(label="Disabled", value=0, emoji="❌"),
        SelectOption(label="Default", value='None', emoji="🔁")
    ])
    async def auto_evidenceformat(self, interaction: Interaction, select: ui.Select): # pylint: disable=unused-argument
        await interaction.response.defer()
        if self.ctx.author != interaction.user:
            await interaction.followup.send("You cannot change this setting for other users.", ephemeral=True)
            return
        if select.values[0] == 'None':
            await config.user(self.ctx.author).auto_evidenceformat.clear()
        else:
            await config.user(self.ctx.author).auto_evidenceformat.set(bool(select.values[0]))
        await interaction.message.edit(embed=await embed(self.ctx))

    @ui.select(cls=ui.Select, placeholder="Epheremal", row=1, options=[
        SelectOption(label="Enabled", value=1, emoji="✅"),
        SelectOption(label="Disabled", value=0, emoji="❌"),
        SelectOption(label="Default", value='None', emoji="🔁")
    ])
    async def ephemeral(self, interaction: Interaction, select: ui.Select): # pylint: disable=unused-argument
        await interaction.response.defer()
        if self.ctx.author != interaction.user:
            await interaction.followup.send("You cannot change this setting for other users.", ephemeral=True)
            return
        if select.values[0] == 'None':
            await config.user(self.ctx.author).history_ephemeral.clear()
        else:
            await config.user(self.ctx.author).history_ephemeral.set(bool(select.values[0]))
        await interaction.message.edit(embed=await embed(self.ctx))

    @ui.select(cls=ui.Select, placeholder="Inline", row=2, options=[
        SelectOption(label="Enabled", value=1, emoji="✅"),
        SelectOption(label="Disabled", value=0, emoji="❌"),
        SelectOption(label="Default", value='None', emoji="🔁")
    ])
    async def inline(self, interaction: Interaction, select: ui.Select): # pylint: disable=unused-argument
        await interaction.response.defer()
        if self.ctx.author != interaction.user:
            await interaction.followup.send("You cannot change this setting for other users.", ephemeral=True)
            return
        if select.values[0] == 'None':
            await config.user(self.ctx.author).history_inline.clear()
        else:
            await config.user(self.ctx.author).history_inline.set(bool(select.values[0]))
        await interaction.message.edit(embed=await embed(self.ctx))
